-- Daily Global Check
-- by Jadya
-- EU-Well of Eternity

-- this is a rough readaptation of the blizzard's tutorial frame, made to avoid taint issues

local addonName, addonTable = ...

local help = DailyGlobalCheck.HelpFunctions
help.buttons = {}
local help_frame
local current_helpplate

local function CreateHelpFrame()
 help.DGCHelpPlate = CreateFrame("Frame")
 help_frame = help.DGCHelpPlate
 help_frame:SetFrameStrata("HIGH")
 help_frame:EnableMouse(true)
end

local function hideplatetooltip()
 HelpPlateTooltip.ArrowUP:Hide()
 HelpPlateTooltip.ArrowGlowUP:Hide()
 HelpPlateTooltip.ArrowDOWN:Hide()
 HelpPlateTooltip.ArrowGlowDOWN:Hide()
 HelpPlateTooltip.ArrowLEFT:Hide()
 HelpPlateTooltip.ArrowGlowLEFT:Hide()
 HelpPlateTooltip.ArrowRIGHT:Hide()
 HelpPlateTooltip.ArrowGlowRIGHT:Hide()
 HelpPlateTooltip:ClearAllPoints()
 HelpPlateTooltip:Hide()
end

local function btn_onenter(self)
 hideplatetooltip()
 
 if ( self.tooltipDir == "UP" ) then
  HelpPlateTooltip.ArrowUP:Show()
  HelpPlateTooltip.ArrowGlowUP:Show()
  HelpPlateTooltip:SetPoint("BOTTOM", self, "TOP", 0, 10);
 elseif ( self.tooltipDir == "DOWN" ) then
  HelpPlateTooltip.ArrowDOWN:Show();
  HelpPlateTooltip.ArrowGlowDOWN:Show();
  HelpPlateTooltip:SetPoint("TOP", self, "BOTTOM", 0, -10);
 elseif ( self.tooltipDir == "LEFT" ) then
  HelpPlateTooltip.ArrowLEFT:Show();
  HelpPlateTooltip.ArrowGlowLEFT:Show();
  HelpPlateTooltip:SetPoint("RIGHT", self, "LEFT", -10, 0);
 elseif ( self.tooltipDir == "RIGHT" ) then
  HelpPlateTooltip.ArrowRIGHT:Show();
  HelpPlateTooltip.ArrowGlowRIGHT:Show();
  HelpPlateTooltip:SetPoint("LEFT", self, "RIGHT", 10, 0);
 end
 
 HelpPlateTooltip.Text:SetText(self.toolTipText)
 HelpPlateTooltip:Show()
 self.box:Hide()
 self.boxHighlight:Show()
 self.Pulse:Stop()
 self.BigI:Hide()
 self.Ring:Hide()
end

local function btn_onleave(self)
 hideplatetooltip()
 
 self.box:Show()
 self.boxHighlight:Hide()
 self.viewed = true
end

local function getButton()
 local f
 
 for i = 1, #help.buttons do
  local button = help.buttons[i]
   if not button:IsShown() then
	frame = button
	break
   end
 end
 
 if not f then
  f = CreateFrame("Button", nil, help_frame, "HelpPlateButton")
  f:SetFrameStrata("HIGH")
  f.box = CreateFrame("Frame", nil, help_frame, "HelpPlateBox")
  f.boxHighlight = CreateFrame("Frame", nil, help_frame, "HelpPlateBoxHighlight")
  f:SetScript("OnEnter", btn_onenter)
  f:SetScript("OnLeave", btn_onleave)
  table.insert(help.buttons, f)
 end
 
 f.tooltipDir = "RIGHT"
 f:SetSize(HELP_BUTTON_NORMAL_SIZE, HELP_BUTTON_NORMAL_SIZE)
 return f
end

function help:Show(plate, p, helpButton)
 if not help_frame then CreateHelpFrame() end
 
 if current_helpplate then help:Hide() end

 current_helpplate = plate
 current_helpplate.mainHelpButton = helpButton
 for i = 1, #current_helpplate do
  if ( not current_helpplate[i].MinLevel or (UnitLevel("player") >= current_helpplate[i].MinLevel) ) then
   local button = getButton()
   button:ClearAllPoints()
   button:SetPoint( "TOPLEFT", help_frame, "TOPLEFT", current_helpplate[i].ButtonPos.x, current_helpplate[i].ButtonPos.y )
   button.tooltipDir = current_helpplate[i].ToolTipDir
   button.toolTipText = current_helpplate[i].ToolTipText
   button.viewed = false
   button:Show()
   button.BigI:Hide()
   button.Ring:Hide()
   button.Pulse:Stop()
   button.box:ClearAllPoints()
   button.box:SetSize( current_helpplate[i].HighLightBox.width, current_helpplate[i].HighLightBox.height )
   button.box:SetPoint( "TOPLEFT", help_frame, "TOPLEFT", current_helpplate[i].HighLightBox.x, current_helpplate[i].HighLightBox.y )
   button.box:Show()
   button.boxHighlight:ClearAllPoints()
   button.boxHighlight:SetSize( current_helpplate[i].HighLightBox.width, current_helpplate[i].HighLightBox.height )
   button.boxHighlight:SetPoint( "TOPLEFT", help_frame, "TOPLEFT", current_helpplate[i].HighLightBox.x, current_helpplate[i].HighLightBox.y )
   button.boxHighlight:Hide()
  end
 end
 
 help_frame:SetScale(p:GetEffectiveScale())
 help_frame:SetPoint( "TOPLEFT", p, "TOPLEFT", plate.FramePos.x, plate.FramePos.y )
 help_frame:SetSize( plate.FrameSize.width, plate.FrameSize.height )
 help_frame:Show()
end

function help:Hide()
 if not help_frame then return end
 
 for i = 1, #help.buttons do
  local button = help.buttons[i]
  button.tooltipDir = "RIGHT"
  button.box:Hide()
  button:Hide()
 end
 current_helpplate = nil
 help_frame:Hide()
 return
end

function help:isShowing(helpplate)
 return current_helpplate == helpplate
end